'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _yamljs = require('yamljs');

var _yamljs2 = _interopRequireDefault(_yamljs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _events = require('events');

var _mqttParser = require('./mqtt-parser');

var _property = require('./validators/property');

var _property2 = _interopRequireDefault(_property);

var _devices = require('./storage/devices');

var _devices2 = _interopRequireDefault(_devices);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _dispatcher = require('./dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Infrastructure = function (_EventEmitter) {
  (0, _inherits3.default)(Infrastructure, _EventEmitter);

  function Infrastructure(options) {
    (0, _classCallCheck3.default)(this, Infrastructure);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Infrastructure).call(this));

    _this.dataDir = options.dataDir;
    _this._representation = _immutable2.default.fromJS({ devices: {} });
    return _this;
  }

  (0, _createClass3.default)(Infrastructure, [{
    key: 'start',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', new _promise2.default(function (resolve, reject) {
                  _this2._config = _yamljs2.default.load(_path2.default.join(_this2.dataDir, '/infrastructure.yml'));
                  _this2._representation = _this2._representation.set('groups', _this2._config.groups);

                  _this2._devicesStorage = new _devices2.default({ dataDir: _this2.dataDir });

                  _this2._config.devices.forEach(function (device) {
                    device = _immutable2.default.fromJS(device);
                    var nodes = _immutable2.default.Map();
                    device.get('nodes').forEach(function (node) {
                      var nodeId = node.get('id');
                      node = node.delete('id');
                      node = node.set('state', _immutable2.default.fromJS({ current: {}, wanted: {} }));
                      nodes = nodes.set(nodeId, node);
                    });
                    _this2._representation = _this2._representation.setIn(['devices', device.get('id')], _immutable2.default.fromJS({
                      location: device.get('location'),
                      color: device.get('color'),
                      state: {
                        online: false
                      },
                      nodes: nodes
                    }));
                  });

                  // If devices don't exist in db let's create them, otherwise populate object

                  _this2._representation.get('devices').forEach(function () {
                    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(device, deviceId) {
                      var doc;
                      return _regenerator2.default.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                              _context2.next = 2;
                              return _this2._devicesStorage.findDevice(deviceId);

                            case 2:
                              doc = _context2.sent;

                              doc = _immutable2.default.fromJS(doc);

                              if (doc) {
                                _context2.next = 8;
                                break;
                              }

                              return _context2.delegateYield(_regenerator2.default.mark(function _callee() {
                                var nodes;
                                return _regenerator2.default.wrap(function _callee$(_context) {
                                  while (1) {
                                    switch (_context.prev = _context.next) {
                                      case 0:
                                        nodes = _immutable2.default.Map();

                                        _this2._representation.get('devices').get(deviceId).get('nodes').forEach(function (node, id) {
                                          node = node.delete('location');
                                          node = node.delete('name');
                                          nodes = nodes.set(id, node);
                                        });

                                        _context.next = 4;
                                        return _this2._devicesStorage.insertDevice({
                                          id: deviceId,
                                          state: device.get('state').toJS(),
                                          nodes: nodes.toJS()
                                        });

                                      case 4:
                                      case 'end':
                                        return _context.stop();
                                    }
                                  }
                                }, _callee, _this2);
                              })(), 't0', 6);

                            case 6:
                              _context2.next = 10;
                              break;

                            case 8:
                              _this2._representation = _this2._representation.setIn(['devices', deviceId, 'state'], doc.get('state'));
                              doc.get('nodes').forEach(function (node, nodeId) {
                                _this2._representation = _this2._representation.setIn(['devices', deviceId, 'nodes', nodeId, 'state'], node.get('state'));
                              });

                            case 10:
                            case 'end':
                              return _context2.stop();
                          }
                        }
                      }, _callee2, _this2);
                    })),
                        _this = _this2;
                    return function (_x, _x2) {
                      return ref.apply(_this, arguments);
                    };
                  }());

                  // Handle MQTT inputs

                  _dispatcher2.default.on('homieMessage', function () {
                    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(parsed) {
                      var online, signal, convertedValue;
                      return _regenerator2.default.wrap(function _callee3$(_context3) {
                        while (1) {
                          switch (_context3.prev = _context3.next) {
                            case 0:
                              if (_this2._representation.get('devices').get(parsed.deviceId)) {
                                _context3.next = 3;
                                break;
                              }

                              _log2.default.debug('device ' + parsed.deviceId + ' not registered');
                              return _context3.abrupt('return');

                            case 3:
                              if (!(parsed.type === _mqttParser.DEVICE_PROPERTY)) {
                                _context3.next = 38;
                                break;
                              }

                              _context3.t0 = parsed.property.name;
                              _context3.next = _context3.t0 === 'ota' ? 7 : _context3.t0 === 'reset' ? 8 : _context3.t0 === 'online' ? 9 : _context3.t0 === 'name' ? 14 : _context3.t0 === 'signal' ? 18 : _context3.t0 === 'fwname' ? 23 : _context3.t0 === 'fwversion' ? 27 : _context3.t0 === 'localip' ? 31 : _context3.t0 === 'nodes' ? 35 : 36;
                              break;

                            case 7:
                              return _context3.abrupt('break', 37);

                            case 8:
                              return _context3.abrupt('break', 37);

                            case 9:
                              online = parsed.property.value === 'true';
                              _context3.next = 12;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: online });

                            case 12:
                              _log2.default.debug(parsed.deviceId + ' is ' + (online ? 'online' : 'offline'));
                              return _context3.abrupt('break', 37);

                            case 14:
                              _context3.next = 16;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 16:
                              _log2.default.debug(parsed.deviceId + ' name is ' + parsed.property.value);
                              return _context3.abrupt('break', 37);

                            case 18:
                              signal = parseInt(parsed.property.value, 10);
                              _context3.next = 21;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: signal });

                            case 21:
                              _log2.default.debug(parsed.deviceId + ' signal is ' + signal + '%');
                              return _context3.abrupt('break', 37);

                            case 23:
                              _context3.next = 25;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 25:
                              _log2.default.debug(parsed.deviceId + ' firmware name is ' + parsed.property.value);
                              return _context3.abrupt('break', 37);

                            case 27:
                              _context3.next = 29;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 29:
                              _log2.default.debug(parsed.deviceId + ' firmware version is ' + parsed.property.value);
                              return _context3.abrupt('break', 37);

                            case 31:
                              _context3.next = 33;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 33:
                              _log2.default.debug(parsed.deviceId + ' IP is ' + parsed.property.value);
                              return _context3.abrupt('break', 37);

                            case 35:
                              return _context3.abrupt('break', 37);

                            case 36:
                              _log2.default.debug(parsed.deviceId + ' sent unknown device property', { propertyName: parsed.property.name, propertyValue: parsed.property.value });

                            case 37:
                              return _context3.abrupt('return');

                            case 38:
                              if (_this2._representation.get('devices').get(parsed.deviceId).get('nodes').get(parsed.nodeId)) {
                                _context3.next = 41;
                                break;
                              }

                              _log2.default.debug('node ' + parsed.nodeId + ' of device ' + parsed.deviceId + ' not registered');
                              return _context3.abrupt('return');

                            case 41:
                              if (_property2.default.canReceive(_this2._representation.get('devices').get(parsed.deviceId).get('nodes').get(parsed.nodeId).get('type'), parsed.property.name, parsed.property.value)) {
                                _context3.next = 44;
                                break;
                              }

                              _log2.default.debug(parsed.deviceId + ' sent bad value', { nodeId: parsed.nodeId, property: parsed.property.name, value: parsed.property.value });
                              return _context3.abrupt('return');

                            case 44:
                              convertedValue = _property2.default.convertValue(_this2._representation.get('devices').get(parsed.deviceId).get('nodes').get(parsed.nodeId).get('type'), parsed.property.name, parsed.property.value);

                              if (!(parsed.type === _mqttParser.SET_NODE_PROPERTY)) {
                                _context3.next = 50;
                                break;
                              }

                              _context3.next = 48;
                              return _this2._updateWantedNodeProperty({ deviceId: parsed.deviceId, nodeId: parsed.nodeId, property: parsed.property.name, value: convertedValue });

                            case 48:
                              _log2.default.debug('device ' + parsed.deviceId + ' node ' + parsed.nodeId + ' - ' + parsed.property.name + ' wanted to ' + convertedValue);
                              return _context3.abrupt('return');

                            case 50:
                              _context3.next = 52;
                              return _this2._updateCurrentNodeProperty({ deviceId: parsed.deviceId, nodeId: parsed.nodeId, property: parsed.property.name, value: convertedValue });

                            case 52:
                              _log2.default.debug('device ' + parsed.deviceId + ' node ' + parsed.nodeId + ' - ' + parsed.property.name + ' = ' + convertedValue);

                            case 53:
                            case 'end':
                              return _context3.stop();
                          }
                        }
                      }, _callee3, _this2);
                    })),
                        _this = _this2;
                    return function (_x3) {
                      return ref.apply(_this, arguments);
                    };
                  }());

                  resolve();
                }));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
      return function start() {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: '_updateDeviceProperty',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(options) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                this.emit('update', {
                  type: 'deviceState',
                  deviceId: options.deviceId,
                  property: options.property,
                  value: options.value
                });
                this._representation = this._representation.setIn(['devices', options.deviceId, 'state', options.property], options.value);
                _context5.next = 4;
                return this._devicesStorage.updateDeviceState({ id: options.deviceId, name: options.property, value: options.value });

              case 4:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
      return function _updateDeviceProperty(_x4) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: '_updateCurrentNodeProperty',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(options) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                this.emit('update', {
                  type: 'nodeCurrentState',
                  deviceId: options.deviceId,
                  nodeId: options.nodeId,
                  property: options.property,
                  value: options.value
                });
                this._representation = this._representation.setIn(['devices', options.deviceId, 'nodes', options.nodeId, 'state', 'current', options.property], options.value);
                _context6.next = 4;
                return this._devicesStorage.updateCurrentNodeState({ deviceId: options.deviceId, nodeId: options.nodeId, name: options.property, value: options.value });

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
      return function _updateCurrentNodeProperty(_x5) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: '_updateWantedNodeProperty',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(options) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this.emit('update', {
                  type: 'nodeWantedState',
                  deviceId: options.deviceId,
                  nodeId: options.nodeId,
                  property: options.property,
                  value: options.value
                });
                this._representation = this._representation.setIn(['devices', options.deviceId, 'nodes', options.nodeId, 'state', 'wanted', options.property], options.value);
                _context7.next = 4;
                return this._devicesStorage.updateWantedNodeState({ deviceId: options.deviceId, nodeId: options.nodeId, name: options.property, value: options.value });

              case 4:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));
      return function _updateWantedNodeProperty(_x6) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: 'sendProperty',
    value: function sendProperty(options) {
      var deviceId = options.deviceId;
      var nodeId = options.nodeId;
      var property = options.property;
      var value = options.value;
      var qos = options.qos || 2;
      var retain = options.retain || true;

      _dispatcher2.default.publishMqttMessage({
        topic: 'devices/' + deviceId + '/' + nodeId + '/' + property + '/set',
        payload: value.toString(),
        qos: qos,
        retain: retain
      });
    }
  }, {
    key: 'getRepresentation',
    value: function getRepresentation() {
      return this._representation.toJS();
    }
  }]);
  return Infrastructure;
}(_events.EventEmitter);

exports.default = Infrastructure;